window.onload = function() {run()};

//定義
//==============================================================================================
var game = new Game();
function Game(){};


var canvasA, ctxA;	//キャンバス
var canvasA, ctxB;
var canvasUI, ctxUI;
var canvasBG, ctxBG;
var canvasBG2, ctxBG2;
var canvasD, ctxD;

var ScreenY = 0;		//カメラの座標

var Width = 1200, 		Height = 700;
var WidthHalf = Width/2, 	HeightHalf = Height/2;

var Draws = 0;

//スプライト格納庫
var ZikiTamas = [];		//弾;
var TekiTamas = [];		//弾;
var Sprites = [];		//敵;
var KeyIndexs = 0;		//敵の識別番号
var SFXs = [];			//エフェクト;

//ステージ
var LevelOffsetX = 0,	LevelOffsetY ;	//ステージの見かけ座標
var LevelSpeedX = -3,	LevelSpeedY ;	//ステージの設定速度
var LevelSpeedHX = 0,	LevelSpeedHY ;	//ステージの実速度

var Level = 0;					//現在のステージ	
var LevelTimer = 0;				//ステージの経過時間
var LevelPhase = 0;				//ステージの区切り
var LevelPhaseTimer = 0;		//区切りの時間
var LevelKage = false;			//影

var Mawasi = 0;					//早回し

var LevelColor = false;			//キャラたちに被せる色

var LevelDebu = {};				//ステージ用の汎用RAM

var SizeX = WidthHalf;			//舞台の大きさ（半分）
var SizeY = 400;

var BlackTimer = 0;				//ブラックアウト
var BlackFlag = true;

var Blacking = 0;				//爆破時の暗さ

var WallTimer = 0;

//内部処理
var Loop = 0, Loop2, Loop3, Loop4, Loop8;	//アニメーション用タイマー
var Timer = 0;				//総フレーム数
var GUIHeight = 0;			//画面上GUIの高さ

//ゲーム状況
var Rank = 1.2;				//ランク
var Zanki = 9;				//残機
var GameMode = "TITLE";		//ゲームの状況
var Pause = false;			//ポーズ中？
var Testing = false;		//デバッグ中？
var Ssbbw = {};				//汎用的フラグ

var Score = 0;

//計算
var PI =		Math.PI;		
var TwoPI = 	Math.PI*2;
var HalfPI = 	Math.PI/2;
var QuarterPI = 	Math.PI/4;

//==============================================================================================
//入力
var keyPulls = {};	var keyPushs = {};

var keys = {one:49, two:50, three:51, for:52, five:53, six:54, seven:55, 8:56, 9:57, 0:48,
	A:65, B:66, C:67, D:68, E:69, F:70, G:71, H:72, I:73, J:74, K:75, L:76, M:77, N:78,
	O:79, P:80, Q:81, R:82, S:83, T:84, U:85, V:86, W:87, X:88, Y:89, Z:90,

	Esc:27,	Space:32,	Shift:16,	Ctrl: 17, Enter: 13, Alt: 18,
	Up:38,	Dw:40,　Ri:39,　Le:37,

	PadUp:5012,	PadDw:5013,	PadRi:5015,	PadLe:5014,
	PadA:5000,	PadB:5001,	PadX:5002,	PadY:5003
}

//イニシャル
//======================================================================================
function run() {

	//キャンバスを宣言
	canvasUI = document.getElementById('canvasUI');
	ctxUI = canvasUI.getContext('2d');
	canvasUI.width = Width;
	canvasUI.height = Height;
	ctxUI.translate(WidthHalf,HeightHalf);

	canvasA = document.getElementById('canvasA');
	ctxA = canvasA.getContext('2d');
	canvasA.width = Width;
	canvasA.height = Height;
	ctxA.translate(WidthHalf,HeightHalf);

	canvasB = document.getElementById('canvasB');
	ctxB = canvasB.getContext('2d');
	canvasB.width = Width;
	canvasB.height = Height;
	ctxB.translate(WidthHalf,HeightHalf);

	canvasBG2 = document.getElementById('canvasBG2');
	ctxBG2 = canvasBG2.getContext('2d');
	canvasBG2.width = Width;
	canvasBG2.height = Height;
	ctxBG2.translate(WidthHalf,HeightHalf);

	canvasBG = document.getElementById('canvasBG');
	ctxBG = canvasBG.getContext('2d');
	canvasBG.width = Width;
	canvasBG.height = Height;

	canvasD = document.getElementById('canvasD');
	ctxD = canvasD.getContext('2d');

	// 右下にＦＰＳ設定
	stats.getDomElement().style.position = "fixed";
	stats.getDomElement().style.right    = "5px";
	stats.getDomElement().style.bottom      = "5px";
	stats.getDomElement().style.userSelect = "none";
	document.body.appendChild(stats.getDomElement());

	game.INIT();

	//ゲームループ呼び出し
	setInterval("game.running()",1000 / 60);
	//game.running();
	
}
//初期化
//======================================================================================
Game.prototype.INIT = function() {
}
var endTime = new Date();
var startTime = new Date();
//メインループ
//======================================================================================
Game.prototype.running = function() {

	GamePadFunc();	//ゲームパッド更新
	
	//startTime = performance.now();

	if (keyPushs[keys.T]) Testing = !Testing;
	Draws = 0;

	if (WallTimer<1) {

		//ゲームモード別処理
		switch (GameMode) {
			case "STG" :
				game.ModeStg();
				break;

			case "TITLE" :
				game.ModeTitle();
				break;

			case "LEVELS" :
				game.ModeLevels();
				break;
			case "GAMEOVER" :
				game.ModeGameOver();
				break;
			case "END" :
				game.ModeEnd();
				break;
		}
	}

	if (WallTimer > 0) {
		const ttt = (1-Math.abs(WallTimer-1))*100;
		const gfx = GFXs["Wall0"],	xlen = 120,	ylen = 70;
		for (var i=0 ; i<ttt ; i++) {
			//var g = Math.min(1,Math.max(0,(WallTimer-i-10)/10));
			var g = 1;
			ctxUI.drawImage(gfx, (i%10)*xlen-WidthHalf, Math.floor(i/10)*ylen-HeightHalf,
				gfx.width*g,gfx.height*g);
		}

		WallTimer = Math.max(0,WallTimer-=0.02);
	}

	//共通
	Loop++;
	Loop2 = (Loop%2==0);	//アニメ用
	Loop3 = (Loop%3==0);
	Loop4 = (Loop%4>2);
	Loop8 = (Loop%8>4);


	keyPushs = {};	//キーボード
	//Pads = [];	//ゲームパッド


	SoundFlags = [];	//音フラグ初期化

	stats.update();	//fps更新
	
	/*endTime = performance.now();
	const fps = endTime - startTime;
	setTimeout("game.running()",1000 / 60 - fps);*/


}
//======================================================================================
//======================================================================================
//======================================================================================